# Thanks and a brief summary of responses 

Dear Reviewers,

Thank you for the valuable comments and constructive suggestions.

We are encouraged to see a wide appreciation of the novel view of efficient Markov chain and penal connection. We have provided detailed response to each reviewer, and `a revision with all review comments/suggestions addressed has been submitted`. By doing so, we hope that the reviewer's concerns could be largely addressed.

Thank you,

The authors.

# Reviewer1

Q1: Central claims of the paper are not clear: Consider the “inefficient” Markov chain in Fig 2 (a). Both the inefficient and efficient Markov chains successfully convert data from the source to the target domain. In fact, for a classification type model there should be no difference in the finally test accuracies of both efficient and inefficient models. If learning an efficient Markov chain is hard, it is not clear what is the advantage of an efficient Markov chain. Perhaps the paper wants to claim that efficient Markov chains leads to better fit to the target distribution?

A1: Thank you for pointing this out. There is a mistake in the illustration of Fig 2(a) that makes you confused. We claim that efficient Markov chains can better fit the target distribution, leading to superior accuracy. We have corrected the figure in the revision.

Because most existing optimizers are inadequate to keep a network in an efficient Markov chain, the network generally shows substandard optimizability.
Therefore, if there is a way, i.e., the proposed penal connection, to explicitly guide the network to be a more efficient chain in the optimization process, it will probably boost the performance.


Q2: In Proof 2.3, the paper derives only an c value for \epsilon. What is the quality of the approximation? Are there any upper bounds to the absolute error? This is important because the approximation has a direct impact on the quality of the proposed regularizer. (The steps in Proof 2.3 should be numbered).

A2: It is an excellent suggestion to dive more profound into the approximation of \epsilon. A detailed analysis of this approximation is presented in the Appendix C in the revision.
We proved that the estimation error of $g_{x_{l}}$ is mainly contributed by the hyper-parameter $\tau$.
(All equations are correctly numbered now.)

Q3: It is not clear if a higher value of \epsilon leads to a better model? The paper should show better evidence for this. 

A3: The value of \epsilon only represents how efficient a Markov chain is, it is not directly corresponding to model accuracy. Consequently, a higher value of $\epsilon$ does not mean higher accuracy. Thus, the value of \epsilon peaks early in training also does not mean that the model will perform optimally at this time.

Q4:In Fig 4 (b) the difference in \epsilon between the two models is minimal. In fact, the value of \epsilon peaks early in training, but is not accompanied by peak accuracy?

A4: Although a more efficient Markov chain ideally leads to better performance, it increases the difficulty of optimization as well. As shown in Fig.4(b), the \epsilon grows rapidly at the beginning of training, which implies that the penal connection mechanism successfully forces the network to be an extremely efficient chain. And then the \epsilon falls sharply and keeps a small positive value close to zero, which is caused by the limitation of existing optimization algorithms that can not optimize the network with an efficient Markov chain. Despite this, the penal connection still helps models get better accuracy. 

Q5: The paper should also consider including additional state of the art baselines for the machine translation task, as currently only the plain Transformer is considered.

A5: Our goal is to validate the effectiveness of the view of the effective Markov chain proposed in this work and improve the network performance by an explicit intervention that makes it to be an effective Markov chain. It is not our purpose to beat all existing methods on a certain task to achieve a new SOTA. Consequently, we conducted several representative tasks both in the fields of NLP and CV and examine the performance improvements of baseline models cooperated with the proposed penal connection.

# Reviewer 2

Q1: The main contribution of this paper has not been summarized. 
A1: Our main contributions can be summarized in two folds.
First, we present a new perspective to understand the skip connection model as a learnable Markov chain and carry out exhaustive theory analysis and experimental verification.
Second, we propose the penal connection, a simple method to enable a network to be optimized within a more efficient Markov chain, which can substantially improve performances both in the fields of NLP and CV.
(See also in the last paragraph of Section: Introduction in the revision.)
 
Q2: In Fig.1, f_{\theta_{l}} is a residual-like block. Can you explain the difference between f_{\theta_{l} and residual block? 

A2: Generally speaking, the residual block refers to the basic block and bottleneck block proposed in the original ResNet paper.
Residual-like block is a broader concept that refers to the block that several computational operations embraced with a skip connection, such as the self-attention block and FFN block in Transformer.
 
Q3: How to understand the definition of ideal direction? The relationship between ℓ(a, c) ≥ ℓ(µa+ (1−µ)b, c) ≥ ℓ(b, c) and Eq.(1). 

A3: Given the error function ℓ, relative to direction $\vec{a}$, any direction $\vec{b}$, which satisfy that ℓ(b) is less than ℓ(a), is the ideal direction of $\vec{a}$.
In other words, whether $\vec{b}$ is an ideal direction of $\vec{a}$ depends on the definition of error function ℓ.
Actually, direction $\vec{a}$ and $\vec{b}$ lie in the same linear space, and the interpolation between $\vec{a}$ and $\vec{b}$ also lies in this space and `ℓ(a, c) ≥ ℓ(µa+ (1−µ)b, c) ≥ ℓ(b, c)` reflects this properties.

Q4: In Fig.4, can you plot the curves about ℓ(xl − ηgxl , y) and ℓ(xl , y) to illustrate ℓ(xl − ηgxl , y) < ℓ(xl , y) always holds?

A4: Since the parameters of the network are constantly changing during the training process, it is almost impossible to require that `ℓ(xl − ηgxl , y) < ℓ(xl , y)` always be established.
The goal of penal connection is not to ensure `ℓ(xl − ηgxl , y) < ℓ(xl , y)` always holds, but to obtain a suitable efficient Markov chain.
In order to better illustrate this relationship, we plot the curves about `ℓ(xl − ηgxl , y) - ℓ(xl , y)` in Appendix D of the revision for the toy model mentioned in Fig. 2 (b).
In most cases, `ℓ(xl − ηgxl , y)` is significantly smaller than `ℓ(xl , y)` and in case of more than 70\%, `ℓ(xl − ηgxl , y) < ℓ(xl , y)` holds. 
This fully demonstrates the effectiveness of our proposed penal connection.
However, finding a better way to make `ℓ(xl − ηgxl , y) < ℓ(xl , y)` hold is worth further exploration.


# Reviewer 3

Q1: Previous works [1,2] have already formulated the VGG-like models with the Markov chain. 
[1] Opening the black box of Deep Neural Networks via Information
[2] Markov Chain Neural Networks

A1: First, [2] proposes a better way of Markov process simulation with neural network. This is a new application of neural network. Our work mainly discusses the optimization behavior of neural network. They belong to two distinct directions and have no obvious correlation.
Second, [1] explains the learning behavior of neural networks from different perspectives. Specifically, [1] regards the feed-forward process of a neural network as a Markov chain as well, and then explains the behavior of neural network in the optimization process from the perspective of Shannon Information Theory. In comparison to our work,
we explain the behavior in the process of network training from the perspective of effective Markov chain.
And we subsequently propose the resultant penal connection that improves performance by explicitly guiding any residual-like network within a more efficient Markov chain.

Q2: Can you explain the advantage of ResNet over VGG under the Markov chain’s guide?

A2: This is a very good question and should be fully discussed. A detail analysis is exhibited in Appendix E in the revision.
Briefly, as long as $\mathcal{C}_{L}(x_{0} \to x_{L})$ is a $\delta$-convex chain, the chain formed by ResNet is more efficient than the one formed by VGG. This is the main reason why ResNet is superiority to VGG with respect to Markov chain. 

Q3: The compared models’ performance in Table 2 is lower than their original paper, can you explain why, and can the proposed method promote their SOTA implementation?

A3: In Experiment 2, we mainly focused on the impact of different $\tau$ on the model performance.
Therefore, we simply take the same training recipes for all networks, except for different batch sizes and corresponding learning rates, which is not suitable for these networks to obtain superior accuracy, resulting in worse performance than presented in their original paper.

We have rerun the experiments with their optimal training recipes to catch up the SOTA performance.
Due to the limitation of rebuttal period time and computation resources, only part of results have been came out at present. We observe penal connection can still improve the SOTA performance.~(The penal connection $\tau$ equals to $3\times 10^{-8}$ for all experiments.)

| model         | baseline  | ours  |
| :--:          | :--:      | :--:  |
| ResNet50      |  79.2     | 79.36 |
| ViT-S/16-224  |  77.8     | 78.09 |
| Swin-S/4-7-224|  83.3     | 83.47 |


# Reviewer 4

Q1: Can authors analyze why the proposed method can solve the model degradation problem? 

A1: We explain this phenomenon in Fig. 7 of Appendix F in the revision. From the illustration, the random initialized Markov chain is prone to move in zigzags and even turn back as the chain goes longer (i.e. the model going deeper), which hinders the model from fitting target distribution efficiently, probably resulting in worse performance.

When we apply penal connection to enforce the network to be an efficient Markov chain, the turn-back chain nodes do not exist so each node takes at least a non-negative effect whatever how long the chain is. As a result, it could alleviate the model degradation problem.

Q2: Will the penal connection make the convolutional layer more sparsity, and can other regularization methods (i.e.  Norm) solve this problem?

A2: Penal connection can be viewed as a special type of regularization acted on gradients of featuremaps, instead of parameters. Thus, it can not directly affect the sparsity of weights.

Moreover, penal connection is a simple approach to guide a network to be a more efficient Markov chain. We believe that there must be other solutions to do better, which is worth exploration in future work.

Q3: Experiments on more deeper networks (i.e. ResNet101, ResNet152, ResNet110, ResNet1202) are needed to evaluate for demonstrating that the Markov chain can better solve the model degradation problem than the residual-like model.

A3: Here, we conduct experiments on ImageNet1K with ResNet101 and ResNet152. We can observe that models with the penal connection can consistently improve performance as the depth goes deeper.~(The penal connection $\tau$ set as $3\times 10^{-8}$.)

| Model     | baseline  | ours  |
| :--:      | :--:      | :--:  |
| ResNet101 |  80.7     | 81.09 |
| ResNet152 |  81.1     | 81.38 |



Q4: I have noticed ReLU is put before Linearly Layer in Figure 1 in the supplementary materials, so the model used in the main paper is whether ResNets or PreActResNets?

A4: Probably there is a misunderstanding. Fig. 1 in the supplementary materials demonstrates the network structure used in the toy model mentioned in Figure 2(b) of the main paper, which is not a model related to ResNet. We only use ResNet anywhere.



